(function( $ ) {
    'use strict';

    $(function() {

        // Buy - Free Feature
        $(document).on('click', '.acf-field-5ed0f4c95f1c8 .acf-button-group', function(ev){
            ev.preventDefault();

            var $iframe = $('#cmb-pro-modal iframe'),
                $modal = $('#cmb-pro-modal'),
                locale = cmb_locale.wordpress_locale,
                $spinner = $('<div class="smb-loader"><div class="spinner-border text-secondary" role="status"><span class="sr-only">Loading...</span></div></div>');

            $modal.modal('show');

            locale = locale.split('_')[0];

            if ( $iframe.attr('src') ) {
                return;
            }

            var src = $iframe.data(locale + '-src');

            if (!src) {
                src = $iframe.data('en-src');
            }

            $modal.find('.modal-body').append($spinner);

            $iframe.attr('src', src).on('load', function(){
                $iframe.removeClass('loading');
                $spinner.remove();
            });
        });

        // Export - PRO feature
        $(document).on('click', '.acf-field-5edce098eada2 .acf-button-group', function(ev){
            ev.preventDefault();

            $.getJSON(ajaxurl, {
                'action': 'cmb_export',
                'security': cmb_pro_nonces.cmb_export
            }, function(resp){

                if (!resp.success) {
                    alert(resp.message);
                    return;
                }

                var blob=new Blob([JSON.stringify(resp.data)]);
                var link=document.createElement('a');
                link.href=window.URL.createObjectURL(blob);
                link.download=resp.filename;
                link.click();
            });

        });

        // Restore - PRO feature
        $(document).on('click', '.acf-field-5edcf602ce08d .acf-button-group', function(ev){
            ev.preventDefault();

            if ( ! confirm(cmb_pro_message.cmb_restore) ) {
                return;
            }

            $.getJSON(ajaxurl, {
                'action': 'cmb_restore',
                'security': cmb_pro_nonces.cmb_restore
            }, function(resp){

                if (!resp.success) {
                    alert(resp.message);
                    return;
                }

                location.reload();
            });

        });

    });

})( jQuery );
