var cmb_mixins = cmb_mixins || {};
cmb_mixins.padding = {};

(function ($,mixin) {
    'use strict';

    var on = function (event, target, fn) {
        $(document).on(event, target, fn);
    };

    if (!String.format) {
        String.format = function (format) {
            var args = Array.prototype.slice.call(arguments, 1);
            return format.replace(/{(\d+)}/g, function (match, number) {
                return typeof args[number] != 'undefined'
                    ? args[number]
                    : match
                    ;
            });
        };
    }

    $(function () {

        var iframe = $('#elementor-preview-iframe')[0].contentWindow,
            $$ = iframe.jQuery,
            generateCss = function ($css, $template) {

                var uuid = String.format('{0}-{1}', $template.data('device'), $template.data('element-id')),
                    dataKey = String.format('{0}:{1}', $template.data('device'), $template.data('device-width')),
                    unit = $template.find('.elementor-units-choices input:checked').val() || 'px',
                    $button = $template.find('button.elementor-link-dimensions'),
                    data = {
                        'type' : 'padding',
                        'device_name' : $template.data('device'),
                        'post_id' : $template.data('post-id'),
                        'element_id' : $template.data('element-id'),
                        'px_checked' : unit === 'px' ? 'checked' : '',
                        'percentage_checked' : unit === '%' ? 'checked' : '',
                        'em_checked' : unit === 'em' ? 'checked' : '',
                        'rem_checked' : unit === 'rem' ? 'checked' : '',
                        'linked' : $button.hasClass('unlinked') ? 'unlinked' : '',
                        'device_width' : $template.data('device-width'),
                        'device_height' : $template.data('device-height'),
                        'unit' : unit
                    }

                ;

                $template.find('.elementor-control-dimension input').each(function () {
                    var $this = $(this);
                    data[$this.data('setting')] = $this.val();
                });

                var storedData = $css.data('devices') || {};

                storedData[dataKey] = data;

                $css.data('devices', storedData);

                $css.trigger('cmb.render.padding.css', storedData);

                mixin[uuid] = data;

                $e.internal('document/save/set-is-modified', {
                    status: true
                });

            };

        on('change', '.codevision-elementor-cmb.cmb-mixin-padding .elementor-control-dimension input', function (ev) {
            var $this = $(this),
                $template = $this.closest('.codevision-elementor-cmb'),
                $css = $$('#cmb-css-padding-' + $template.data('element-id')),
                $linked = $template.find('button.elementor-link-dimensions')
                ;

            if ($template.data('link-change') === 'in-progress') {
                return;
            }

            if (!$linked.hasClass('unlinked')) {
                $template.data('link-change', 'in-progress')
                $template.find('.elementor-control-dimensions input').val($this.val());
                $template.data('link-change', '')
            }

            generateCss($css, $template);

        });

        $$(iframe.document).on('cmb.render.padding.css', 'style', function(event, settings){
            var $css = $(this),
                keys = Object.keys(settings),
                device_size = '@media (max-width: {0}px)',
                element_selector = '.elementor-{0} .elementor-element.elementor-element-{1} > .elementor-widget-container',
                element_css = 'padding-{0}: {1}{2};',
                rules = [];

            keys = keys.sort(function(a,b){
                var compond_a = a.split(':'),
                    compond_b = b.split(':');

                return (parseInt(compond_b[1]) - parseInt(compond_a[1]));
            });

            $.each(keys, function(idx, key){
                var setting = settings[key],
                    css = [
                        String.format(device_size, setting.device_width),
                        '{',
                        String.format(element_selector, setting.post_id, setting.element_id),
                        '{'
                    ];

                $.each(['top', 'left', 'bottom', 'right'], function(idx, rule){
                    css.push(String.format(element_css, rule, setting[rule], setting.unit));
                });
                css.push('}');
                css.push('}');
                rules.push(css.join(''));
            });

            $css.text(rules.join(''));
        });

    });

})(jQuery, cmb_mixins.padding);
