<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.codevision.io
 * @since             1.0.0
 * @package           Codevision_Elementor_Cmb
 *
 * @wordpress-plugin
 * Plugin Name:       Custom Mobile Breakpoints Pro for Elementor
 * Plugin URI:        https://www.codevision.io
 * Description:       Finally you can add custom mobile breakpoints to your elementor editor view!
 * Version:           2.0.1
 * Author:            Codevision
 * Author URI:        https://www.codevision.io
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       codevision-elementor-cmb
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
    die;
}

include_once __DIR__ . '/vendor/autoload.php';

define( 'CMB_DEBUG', false );

define( 'CMB_VERSION', '2.0.1' );
define( 'CMB_MIN_PHP', '7.3' );
define( 'CMB_MIN_WP', '5.4.0' );

define( 'CMB_LICENSE_SERVER_URL', 'https://license.codevision.io');
define( 'CMB_ROOT', __DIR__ );
define( 'CMB_ROOT_FILE', __FILE__ );
define( 'CMB_REQUIRE', __DIR__ . '/required');
define( 'CMB_SLUG', 'codevision-elementor-cmb' );
define( 'CMB_DEVICES_SIGNATURE',  __DIR__ . '/required/verification/signature.dat' );
define( 'CMB_PUBLIC_KEY', __DIR__ . '/required/verification/public-key.pem' );
define( 'CMB_NAME', 'Custom Mobile Breakpoints for Elementor' );
define( 'CMB_SOURCE_JS', '6ed5d5bc-a138-4ed5-8983-6a616eb2d098.js');
define( 'CMB_TEMPLATE_DIR', __DIR__ . '/admin/templates');
define( 'CMB_PUBLIC_CSS', __DIR__ . '/public/css');

function activate_codevision_elementor_cmb() {

    Codevision_Elementor_Cmb_Activator::activate();
}

function deactivate_codevision_elementor_cmb() {

    Codevision_Elementor_Cmb_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_codevision_elementor_cmb' );

do_action('codevision/cmb/init_plugin');
